#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "array4xi.py">
#<abstract4xi abstract = "Provides function Array4Xi" />
#<refer4xi reference = "managers.py" />
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "Function name starts with capital" />
# -------------------------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'Array4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass    
try:                 # most-common ones
    import weakref
    import queue
    from traceback import format_exc         
except:
    pass
try:                 # rare ones
    import array        
except:
    pass 
      
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.managers import Array
except:
    print("array4xi.py *** failed in from multiprocessing.managers import Array ***")
#"
#/>
 
# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from print4xi import print4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "Array4Xi" usage = "
#     managers.py: SyncManager.register('Array', Array, ArrayProxy)
#     syncmanager4xi.py: SyncManager.register('Array4Xi', Array4Xi, ArrayProxy4Xi)
#
#     test_array4xi.py
#         typecode4xi = 'u'
#         sequence4xi = []
#         lock4xi = Lock4Xi()
#         xi = Array4Xi(typecode4xi, sequence4xi, lock4xi)
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def Array4Xi(typecode, sequence, lock=True):
    '''
    Array4Xi function returns Array
    
    '''    

    # -----------------------------------------------------------------------------------------
    #           
    # -----------------------------------------------------------------------------------------
    class2print = 'Array4Xi'
    method2print = 'Array4Xi'
    
    message2print = "{started" + "; Array4Xi-started: " + str(Array4Xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)     
    # 02:35:26 02/12/13 Pacific Standard Time
    
    message2print = "{passed" + "; typecode-passed-to-Array4Xi: " + str(typecode) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    # u
    
    # verified that you can NOT trace sequence!
    # message2print = "{passed" + "; sequence-passed-to-Array4Xi: " + str(sequence) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)      
    # try:
    #     print("sequence-passed-to-Array4Xi: ", sequence)
    # except:
    #    print("*** failed to print sequence-passed-to-Array4Xi ")
       
    message2print = "{passed" + "; lock-passed-to-Array4Xi: " + str(lock) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)      
          
    
    message2print = "{returning" + "; array-function-returning-by-Array4Xi: " + str(array.array) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
    # <class 'array.array'>
    
    # message2print = "{returning" + "; Array4Xi-returning: " + time4xi() + "}" 
    # print4xi(class2print, method2print, message2print) 
    #    
    
    return array.array(typecode, sequence)

    # ---------------------------------------------------------------------------------------------
    # Array
    # Type code C Type Python Type Minimum size in bytes 
    # 'c' char character 1 
    # 'b' signed char int 1 
    # 'B' unsigned char int 1 
    # 'u' Py_UNICODE Unicode character 2 
    # 'h' signed short int 2 
    # 'H' unsigned short int 2 
    # 'i' signed int int 2 
    # 'I' unsigned int long 2 
    # 'l' signed long int 4 
    # 'L' unsigned long long 4 
    # 'f' float float 4 
    # 'd' double float 8 
    # ---------------------------------------------------------------------------------------------
#</function4xi>
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

    
    


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of array4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



